#!/usr/bin/perl

# Galaxy wrapper implemented by Roger Ngo and Todd H. Oakley, UCSB

my $illuQCPath = '/home/galaxy/galaxy_dist/tools/IlluQC_p/IlluQC_PRLL.pl';

my $peOrSe = $ARGV[0];
my $forwardsInput = $ARGV[1];
my $reverseInput = $ARGV[2];
my $primer_adaptor = $ARGV[3];
my $fastq_variants = $ARGV[4];
my $cutOffReadLen4HQ = $ARGV[5];
my $cutOffQualScore = $ARGV[6];
my $adaptorFile = $ARGV[7];

$f_in1 = qx/cp $forwardsInput forwards/;
$f_in2 = qx/cp $reverseInput reverse/;

if($peOrSe eq "1") {
	# -pe
	if($primer_adaptor eq "F") {
		my $run = qx/$illuQCPath -pe forwards reverse $adaptorFile $fastq_variants -l $cutOffReadLen4HQ -s $cutOffQualScore -c 10 -o . 1>runLog.txt 2>log.txt/;
	}
	else {
		my $run = qx/$illuQCPath -pe forwards reverse $primer_adaptor $fastq_variants -l $cutOffReadLen4HQ -s $cutOffQualScore -c 10 -o . 1>runLog.txt 2>log.txt/;
	}
}
elsif($peOrSe eq "0") {
	# -se
	if($primer_adaptor eq "F") {
		my $run = qx/$illuQCPath -se forwards $adaptorFile $fastq_variants -l $cutOffReadLen4HQ -s $cutOffQualScore -c 10 -o . 1>runLog.txt 2>log.txt/;
	}
	else {
		my $run = qx/$illuQCPath -se forwards $primer_adaptor $fastq_variants -l $cutOffReadLen4HQ -s $cutOffQualScore -c 10 -o . 1>runLog.txt 2>log.txt/; 
	}
}
