#!/usr/bin/perl

# Script written by Roger Ngo, and Todd H. Oakley, UCSB

my $scriptPath = "\/home\/galaxy\/galaxy_dist\/tools\/bioperl";
my $numDiffGenes = $ARGV[1];
my $i;
my @datFiles;
my $argIndex = 3;
for($i = 0; $i < $numDiffGenes; $i++) {
	$datFiles[$i] = $ARGV[$argIndex];
	$argIndex++;
}

my $list = $ARGV[2];
my $outputFile = $ARGV[0];

my $tempResultFile = "tempResult.txt";
my $contentsFile = "contents.txt";

open(FILE, $outputFile);
open(TEMP, '>'.$tempResultFile);
open(CONTENTS, '>'.$contentsFile);

my $count;
my $count2;
my $currLine;

while ($currLine = <FILE>) {
	if($currLine =~ m/PRESENT/) {
		$count = () = $currLine =~ /\t/g;
		if($count == ($numDiffGenes + 1)) {
			$currLine = substr($currLine, 8);
			my @tempGeneArray = split(/\t/, $currLine);
			
			for($count2 = 0; $count2 <= $numDiffGenes; $count2++) {
				my @currentGeneArray = split(/\|/, $tempGeneArray[$count2]);
				if($currentGeneArray[0] =~ m/jgi/) {
					print TEMP $currentGeneArray[1];
					print TEMP "\t";
				}
				else {
					if($currentGeneArray[0] =~ s/\n/\t\n/g) {
						print TEMP $currentGeneArray[0];
					}
					else {
						print TEMP $currentGeneArray[0];
						print TEMP "\t";
					}
				}
			}
			print CONTENTS $currLine;
		}
	}	
}

close(CONTENTS);
close(TEMP);
close(FILE);

open(TEMP, $tempResultFile);

my $flag = 1;
my @correspondingLines;
my $element = 1;
my $corrLineArraySize = 0;

while($currLine = <TEMP>) {
	@tempArray = split(/\t/, $currLine);
	for($count = 0; $count < $numDiffGenes; $count++) {
		for($count2 = $count + 1; $count2 < $numDiffGenes; $count2++) {
			my $sub0 = substr($tempArray[$count], 0, 3);
			my $sub1 = substr($tempArray[$count2], 0, 3);
			if($tempArray[$count] eq $tempArray[$count2]) {
				$flag = 0;
			}
			if( $sub0 =~ m/[0-9]/ && $sub1  =~ m/[0-9]/ ) {
				$flag = 0;
			}
		}
	}
	if($flag == 1) {
		$correspondingLines[$corrLineArraySize] = $element;
		$corrLineArraySize++;
	}
	$element++;
	$flag = 1;
}

close(TEMP);

open(CONTENTS, $contentsFile);
open(TEMP, '>'.$tempResultFile);
my $lineNum = 1;

$count = 0;

while($count < $corrLineArraySize) {
	$currLine = <CONTENTS>;
	my @tempArray = split(/PRESENT\t/, $currLine);
	if ($correspondingLines[$count] == $lineNum) {
		print TEMP "@tempArray";
		$count++;
	}
	$lineNum++;
}

close(TEMP);
close(CONTENTS);

my @files = @datFiles;

my $fileString = "@files";

my $newList;
for($count = 0; $count < length($list); $count++) {
	if(substr($list, $count, 1) eq ')' || substr($list, $count, 1) eq '(' || substr($list, $count, 1) eq ',') {
	}
	else {
		my $nextIndex = $count + 1;
		$newList = $newList.substr($list, $count, 1);
		if(substr($list, $nextIndex, 1) eq ')' || substr($list, $nextIndex, 1) eq '(' || substr($list, $nextIndex, 1) eq ',') 
		{
			$newList = $newList.' ';
		}
	}
}

$count = 0;
open(TEMP, $tempResultFile);
open(OUTFILE, '>'."result.dat");
while($count < $corrLineArraySize) {
	my $currentSequenceLine = <TEMP>;
	my $sysCmd = qx/perl $scriptPath\/pull_seqs_by_name.pl \'$count\' \'$fileString\' \'$currentSequenceLine\' \'$newList\'/;
	print OUTFILE $sysCmd; 
	$count++;
}
close(OUTFILE);
close(TEMP);
unlink("contents.txt");
unlink("tempResult.txt");

