#!/usr/bin/perl

use strict;

use FindBin;
use lib "$FindBin::Bin/lib";
use Bio::DB::Fasta;
use Bio::SeqIO;
use Bio::Seq;

my @speciesList = split(/ /, $ARGV[3]);

my @fileArray;
my @passed = split(/ /, $ARGV[1]);
my $substr;
my $gene;
my $file;
$ARGV[2] =~ s/\|/\\|/g;
my @genes = split(/\t/, $ARGV[2]);

foreach $substr (@passed) {
	push(@fileArray, Bio::SeqIO->new(-file => $substr, '-format' =>'fasta'));
}

my $count = 0;
foreach $file (@fileArray) {
	while (my $seq = $file->next_seq()) {
		my $seq_obj = $file;
		foreach $gene (@genes) {
			if ($seq->id =~ m/^$gene$/) {
				if($seq->seq){
					#$passed[$count] =~ s/^.fasta$//g;
					print $speciesList[$count]."\t";
					print "GeneFamily".$ARGV[0]."\t";
					print $seq->id."\t";
					print $seq->seq."\n";
				}
			}
		}
	}
	$count++;
}
